﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace TreeViewLODSL4
{
	public class ViewModel : INotifyPropertyChanged
	{
		public ViewModel(string header)
		{
			this.Header = header;
			this.Children = new ObservableCollection<ViewModel>();
		}

		private String header;
		/// <summary>
		///     Gets or sets the name.
		/// </summary>
		public String Header
		{
			get
			{
				return this.header;
			}
			internal set
			{
				if (this.header != value)
				{
					this.header = value;
					OnPropertyChanged("Header");
				}
			}
		}

		public ObservableCollection<ViewModel> Children { get; set; }


		/// <summary>
		///     Event for INotifyPropertyChanged.
		/// </summary>
		public event PropertyChangedEventHandler PropertyChanged;

		/// <summary>
		///     Raises the INotifyPropertyChanged event.
		/// </summary>
		/// <param name="propertyName">The property to be included in the INotifyPropertyChanged EventArgs.</param>
		protected virtual void OnPropertyChanged(String propertyName)
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
			}
		}
        
	}
}
